/*EASE$$$ READ ONLY COPY of file CQD.r
** 1.1	dba 08/15/1989  fixed green channel of green in DefQDColors clut (127);
**		also removed names of cluts
** 1.0	BBM 2/12/88 Adding file for the first time into EASE
** END EASE MODIFICATION HISTORY */
/*  Standard CLUT resource definitions for Color QuickDraw  */
/*															*/
/*	Modification History									*/
/*  DeRez'd 14 October EHB  								*/
/*	Renumbered resources, changed 2BitStd to grays			*/
/*  Filled out low bytes of all values by duplicating highs */
/*  Changed ID of CLUT 1 to 1 (from 0)						*/
/*  Changed ID of CLUT 8 to 8 (from 6)						*/
/*  Changed 'CLUT' to 'clut'								*/
/*  13Jan87 EHB - Added 'clut' 127 for standard colors		*/
/*  24Jan87 EHB - Revised 4 bit standard and QDColors to use new system colors */
/*  c747 03Feb87 EHB - New set of 4-bit standard colors */
/*  C758 04Feb87 DAF - Modified gray levels in clut=4 to be evenly spaced	*/
/*	C777 09Feb87 DAF - Set hi bit of transIndex on and cleared .value fields	*/
/*  C814 13Feb87 EHB - Final!? 4-bit colors */
/*  C385 20Feb87 DAF - Added mitq=0 resource for MakeITable		*/

data 'clut' (1) {
	$"0000 0001 8000 0001 0000 FFFF FFFF FFFF"        /* ................ */
	$"0000 0000 0000 0000"                            /* ........ */
};

data 'clut' (2) {
	$"0000 0002 8000 0003 0000 FFFF FFFF FFFF"
	$"0000 ACAC ACAC ACAC 0000 5555 5555 5555"
	$"0000 0000 0000 0000"                
};

data 'clut' (4) {
	$"0000 0004 8000 000F 0000 FFFF FFFF FFFF" 
	$"0000 FC00 F37D 052F 0000 FFFF 648A 028C" 
	$"0000 DD6B 08C2 06A2 0000 F2D7 0856 84EC" 
	$"0000 46E3 0000 A53E 0000 0000 0000 D400" 
	$"0000 0241 AB54 EAFF 0000 1F21 B793 1431"
	$"0000 0000 64AF 11B0 0000 5600 2C9D 0524" 
	$"0000 90D7 7160 3A34 0000 C000 C000 C000"
	$"0000 8000 8000 8000 0000 4000 4000 4000"
	$"0000 0000 0000 0000" 
};

data 'clut' (8) {
	$"0000 0008 8000 00FF 0000 FFFF FFFF FFFF"        /* ................ */
	$"0000 FFFF FFFF CCCC 0000 FFFF FFFF 9999"        /* .............. */
	$"0000 FFFF FFFF 6666 0000 FFFF FFFF 3333"        /* ......f.......3. */
	$"0000 FFFF FFFF 0000 0000 FFFF CCCC FFFF"        /* ............... */
	$"0000 FFFF CCCC CCCC 0000 FFFF CCCC 9999"        /* ............ */
	$"0000 FFFF CCCC 6666 0000 FFFF CCCC 3333"        /* ....f......3. */
	$"0000 FFFF CCCC 0000 0000 FFFF 9999 FFFF"        /* .............. */
	$"0000 FFFF 9999 CCCC 0000 FFFF 9999 9999"        /* ........... */
	$"0000 FFFF 9999 6666 0000 FFFF 9999 3333"        /* .....f......3. */
	$"0000 FFFF 9999 0000 0000 FFFF 6666 FFFF"        /* ...........f... */
	$"0000 FFFF 6666 CCCC 0000 FFFF 6666 9999"        /* ....f......f.. */
	$"0000 FFFF 6666 6666 0000 FFFF 6666 3333"        /* ....f.f.....f.3. */
	$"0000 FFFF 6666 0000 0000 FFFF 3333 FFFF"        /* ....f.......3... */
	$"0000 FFFF 3333 CCCC 0000 FFFF 3333 9999"        /* ....3......3.. */
	$"0000 FFFF 3333 6666 0000 FFFF 3333 3333"        /* ....3.f.....3.3. */
	$"0000 FFFF 3333 0000 0000 FFFF 0000 FFFF"        /* ....3........... */
	$"0000 FFFF 0000 CCCC 0000 FFFF 0000 9999"        /* ........ ..... */
	$"0000 FFFF 0000 6666 0000 FFFF 0000 3333"        /* .!....f.."....3. */
	$"0000 FFFF 0000 0000 0000 CCCC FFFF FFFF"        /* .#.......$..... */
	$"0000 CCCC FFFF CCCC 0000 CCCC FFFF 9999"        /* .%.....&.... */
	$"0000 CCCC FFFF 6666 0000 CCCC FFFF 3333"        /* .'...f..(...3. */
	$"0000 CCCC FFFF 0000 0000 CCCC CCCC FFFF"        /* .)......*.... */
	$"0000 CCCC CCCC CCCC 0000 CCCC CCCC 9999"        /* .+....,... */
	$"0000 CCCC CCCC 6666 0000 CCCC CCCC 3333"        /* .-..f.....3. */
	$"0000 CCCC CCCC 0000 0000 CCCC 9999 FFFF"        /* ./.....0.... */
	$"0000 CCCC 9999 CCCC 0000 CCCC 9999 9999"        /* .1....2... */
	$"0000 CCCC 9999 6666 0000 CCCC 9999 3333"        /* .3..f..4..3. */
	$"0000 CCCC 9999 0000 0000 CCCC 6666 FFFF"        /* .5.....6.f... */
	$"0000 CCCC 6666 CCCC 0000 CCCC 6666 9999"        /* .7.f...8.f.. */
	$"0000 CCCC 6666 6666 0000 CCCC 6666 3333"        /* .9.f.f..:.f.3. */
	$"0000 CCCC 6666 0000 0000 CCCC 3333 FFFF"        /* .;.f....<.3... */
	$"0000 CCCC 3333 CCCC 0000 CCCC 3333 9999"        /* .=.3...>.3.. */
	$"0000 CCCC 3333 6666 0000 CCCC 3333 3333"        /* .?.3.f..@.3.3. */
	$"0000 CCCC 3333 0000 0000 CCCC 0000 FFFF"        /* .A.3....B..... */
	$"0000 CCCC 0000 CCCC 0000 CCCC 0000 9999"        /* .C.....D.... */
	$"0000 CCCC 0000 6666 0000 CCCC 0000 3333"        /* .E...f..F...3. */
	$"0000 CCCC 0000 0000 0000 9999 FFFF FFFF"        /* .G......H..... */
	$"0000 9999 FFFF CCCC 0000 9999 FFFF 9999"        /* .I.....J.... */
	$"0000 9999 FFFF 6666 0000 9999 FFFF 3333"        /* .K...f..L...3. */
	$"0000 9999 FFFF 0000 0000 9999 CCCC FFFF"        /* .M......N.... */
	$"0000 9999 CCCC CCCC 0000 9999 CCCC 9999"        /* .O....P... */
	$"0000 9999 CCCC 6666 0000 9999 CCCC 3333"        /* .Q..f..R..3. */
	$"0000 9999 CCCC 0000 0000 9999 9999 FFFF"        /* .S.....T.... */
	$"0000 9999 9999 CCCC 0000 9999 9999 9999"        /* .U....V... */
	$"0000 9999 9999 6666 0000 9999 9999 3333"        /* .W..f..X..3. */
	$"0000 9999 9999 0000 0000 9999 6666 FFFF"        /* .Y.....Z.f... */
	$"0000 9999 6666 CCCC 0000 9999 6666 9999"        /* .[.f...\.f.. */
	$"0000 9999 6666 6666 0000 9999 6666 3333"        /* .].f.f..^.f.3. */
	$"0000 9999 6666 0000 0000 9999 3333 FFFF"        /* ._.f....`.3... */
	$"0000 9999 3333 CCCC 0000 9999 3333 9999"        /* .a.3...b.3.. */
	$"0000 9999 3333 6666 0000 9999 3333 3333"        /* .c.3.f..d.3.3. */
	$"0000 9999 3333 0000 0000 9999 0000 FFFF"        /* .e.3....f..... */
	$"0000 9999 0000 CCCC 0000 9999 0000 9999"        /* .g.....h.... */
	$"0000 9999 0000 6666 0000 9999 0000 3333"        /* .i...f..j...3. */
	$"0000 9999 0000 0000 0000 6666 FFFF FFFF"        /* .k......lf..... */
	$"0000 6666 FFFF CCCC 0000 6666 FFFF 9999"        /* .mf.....nf.... */
	$"0000 6666 FFFF 6666 0000 6666 FFFF 3333"        /* .of...f..pf...3. */
	$"0000 6666 FFFF 0000 0000 6666 CCCC FFFF"        /* .qf......rf.... */
	$"0000 6666 CCCC CCCC 0000 6666 CCCC 9999"        /* .sf....tf... */
	$"0000 6666 CCCC 6666 0000 6666 CCCC 3333"        /* .uf..f..vf..3. */
	$"0000 6666 CCCC 0000 0000 6666 9999 FFFF"        /* .wf.....xf.... */
	$"0000 6666 9999 CCCC 0000 6666 9999 9999"        /* .yf....zf... */
	$"0000 6666 9999 6666 0000 6666 9999 3333"        /* .{f..f..|f..3. */
	$"0000 6666 9999 0000 0000 6666 6666 FFFF"        /* .}f.....~f.f... */
	$"0000 6666 6666 CCCC 0000 6666 6666 9999"        /* ..f.f...f.f.. */
	$"0000 6666 6666 6666 0000 6666 6666 3333"        /* .f.f.f..f.f.3. */
	$"0000 6666 6666 0000 0000 6666 3333 FFFF"        /* .f.f....f.3... */
	$"0000 6666 3333 CCCC 0000 6666 3333 9999"        /* .f.3...f.3.. */
	$"0000 6666 3333 6666 0000 6666 3333 3333"        /* .f.3.f..f.3.3. */
	$"0000 6666 3333 0000 0000 6666 0000 FFFF"        /* .f.3....f..... */
	$"0000 6666 0000 CCCC 0000 6666 0000 9999"        /* .f.....f.... */
	$"0000 6666 0000 6666 0000 6666 0000 3333"        /* .f...f..f...3. */
	$"0000 6666 0000 0000 0000 3333 FFFF FFFF"        /* .f......3..... */
	$"0000 3333 FFFF CCCC 0000 3333 FFFF 9999"        /* .3.....3.... */
	$"0000 3333 FFFF 6666 0000 3333 FFFF 3333"        /* .3...f..3...3. */
	$"0000 3333 FFFF 0000 0000 3333 CCCC FFFF"        /* .3......3.... */
	$"0000 3333 CCCC CCCC 0000 3333 CCCC 9999"        /* .3....3... */
	$"0000 3333 CCCC 6666 0000 3333 CCCC 3333"        /* .3..f..3..3. */
	$"0000 3333 CCCC 0000 0000 3333 9999 FFFF"        /* .3.....3.... */
	$"0000 3333 9999 CCCC 0000 3333 9999 9999"        /* .3....3... */
	$"0000 3333 9999 6666 0000 3333 9999 3333"        /* .3..f..3..3. */
	$"0000 3333 9999 0000 0000 3333 6666 FFFF"        /* .3.....3.f... */
	$"0000 3333 6666 CCCC 0000 3333 6666 9999"        /* .3.f...3.f.. */
	$"0000 3333 6666 6666 0000 3333 6666 3333"        /* .3.f.f..3.f.3. */
	$"0000 3333 6666 0000 0000 3333 3333 FFFF"        /* .3.f....3.3... */
	$"0000 3333 3333 CCCC 0000 3333 3333 9999"        /* .3.3...3.3.. */
	$"0000 3333 3333 6666 0000 3333 3333 3333"        /* .3.3.f..3.3.3. */
	$"0000 3333 3333 0000 0000 3333 0000 FFFF"        /* .3.3....3..... */
	$"0000 3333 0000 CCCC 0000 3333 0000 9999"        /* .3.....3.... */
	$"0000 3333 0000 6666 0000 3333 0000 3333"        /* .3...f..3...3. */
	$"0000 3333 0000 0000 0000 0000 FFFF FFFF"        /* .3............ */
	$"0000 0000 FFFF CCCC 0000 0000 FFFF 9999"        /* ............ */
	$"0000 0000 FFFF 6666 0000 0000 FFFF 3333"        /* .....f......3. */
	$"0000 0000 FFFF 0000 0000 0000 CCCC FFFF"        /* ............. */
	$"0000 0000 CCCC CCCC 0000 0000 CCCC 9999"        /* .......... */
	$"0000 0000 CCCC 6666 0000 0000 CCCC 3333"        /* ....f.....3. */
	$"0000 0000 CCCC 0000 0000 0000 9999 FFFF"        /* ............ */
	$"0000 0000 9999 CCCC 0000 0000 9999 9999"        /* .......... */
	$"0000 0000 9999 6666 0000 0000 9999 3333"        /* ....f.....3. */
	$"0000 0000 9999 0000 0000 0000 6666 FFFF"        /* .........f... */
	$"0000 0000 6666 CCCC 0000 0000 6666 9999"        /* ...f.....f.. */
	$"0000 0000 6666 6666 0000 0000 6666 3333"        /* ...f.f....f.3. */
	$"0000 0000 6666 0000 0000 0000 3333 FFFF"        /* ...f......3... */
	$"0000 0000 3333 CCCC 0000 0000 3333 9999"        /* ...3.....3.. */
	$"0000 0000 3333 6666 0000 0000 3333 3333"        /* ...3.f....3.3. */
	$"0000 0000 3333 0000 0000 0000 0000 FFFF"        /* ...3.......... */
	$"0000 0000 0000 CCCC 0000 0000 0000 9999"        /* ............ */
	$"0000 0000 0000 6666 0000 0000 0000 3333"        /* .....f......3. */
	$"0000 EEEE 0000 0000 0000 DDDD 0000 0000"        /* .............. */
	$"0000 BBBB 0000 0000 0000 AAAA 0000 0000"        /* .............. */
	$"0000 8888 0000 0000 0000 7777 0000 0000"        /* .........w..... */
	$"0000 5555 0000 0000 0000 4444 0000 0000"        /* ..U.......D..... */
	$"0000 2222 0000 0000 0000 1111 0000 0000"        /* .."............. */
	$"0000 0000 EEEE 0000 0000 0000 DDDD 0000"        /* ................ */
	$"0000 0000 BBBB 0000 0000 0000 AAAA 0000"        /* .............. */
	$"0000 0000 8888 0000 0000 0000 7777 0000"        /* ...........w... */
	$"0000 0000 5555 0000 0000 0000 4444 0000"        /* ....U.......D... */
	$"0000 0000 2222 0000 0000 0000 1111 0000"        /* ...."........... */
	$"0000 0000 0000 EEEE 0000 0000 0000 DDDD"        /* ................ */
	$"0000 0000 0000 BBBB 0000 0000 0000 AAAA"        /* .............. */
	$"0000 0000 0000 8888 0000 0000 0000 7777"        /* .............w. */
	$"0000 0000 0000 5555 0000 0000 0000 4444"        /* ......U.......D. */
	$"0000 0000 0000 2222 0000 0000 0000 1111"        /* ......"......... */
	$"0000 EEEE EEEE EEEE 0000 DDDD DDDD DDDD"        /* ................ */
	$"0000 BBBB BBBB BBBB 0000 AAAA AAAA AAAA"        /* .......... */
	$"0000 8888 8888 8888 0000 7777 7777 7777"        /* .......w.w.w. */
	$"0000 5555 5555 5555 0000 4444 4444 4444"        /* ..U.U.U...D.D.D. */
	$"0000 2222 2222 2222 0000 1111 1111 1111"        /* .."."."......... */
	$"0000 0000 0000 0000"                            /* ........ */
};


/*  This table contains the 8 default QuickDraw colors  */
/*  They all exactly match elements of '4BitStd'. 		*/

data 'clut' (127) {
	$"0000 007F 0000 0007"
	$"0000 0000 0000 0000"
	$"0001 FC00 F37D 052F"
	$"0002 F2D7 0856 84EC"
	$"0003 DD6B 08C2 06A2"
	$"0004 0241 AB54 EAFF"
	$"0005 0000 8000 11B0"	/* <1.1> */
	$"0006 0000 0000 D400"
	$"0007 FFFF FFFF FFFF"
};

data 'gama' (0, "StdGamma") {
    $"0000"						/* gamma version = 0				*/
    $"0000"						/* gamma type = 0					*/
    $"0000"						/* no formula data in this resource	*/
    $"0001"						/* 1 channel						*/
    $"0100"						/* 256 bytes per table				*/
    $"0008"						/* 8 bits per entry					*/
    $"0005 090B"        							  /* ............... */
	$"0E10 1315 1719 1B1D 1E20 2224 2527 282A"        /* ......... "$%'(* */
	$"2C2D 2F30 3133 3436 3738 3A3B 3C3E 3F40"        /* ,-/0134678:;<>?@ */
	$"4243 4445 4748 494A 4B4D 4E4F 5051 5254"        /* BCDEGHIJKMNOPQRT */
	$"5556 5758 595A 5B5C 5E5F 6061 6263 6465"        /* UVWXYZ[\^_`abcde */
	$"6667 6869 6A6B 6C6D 6E6F 7071 7273 7475"        /* fghijklmnopqrstu */
	$"7677 7879 7A7B 7C7D 7E7F 8081 8182 8384"        /* vwxyz{|}~. */
	$"8586 8788 898A 8B8C 8C8D 8E8F 9091 9293"        /*  */
	$"9495 9596 9798 999A 9B9B 9C9D 9E9F A0A1"        /*  */
	$"A1A2 A3A4 A5A6 A6A7 A8A9 AAAB ABAC ADAE"        /*  */
	$"AFB0 B0B1 B2B3 B4B4 B5B6 B7B8 B8B9 BABB"        /*  */
	$"BCBC BDBE BFC0 C0C1 C2C3 C3C4 C5C6 C7C7"        /*  */
	$"C8C9 CACA CBCC CDCD CECF D0D0 D1D2 D3D3"        /*  */
	$"D4D5 D6D6 D7D8 D9D9 DADB DCDC DDDE DFDF"        /* .......... */
	$"E0E1 E1E2 E3E4 E4E5 E6E7 E7E8 E9E9 EAEB"        /* ................ */
	$"ECEC EDEE EEEF F0F1 F1F2 F3F3 F4F5 F5F6"        /* ................ */
	$"F7F8 F8F9 FAFA FBFC FCFD FEFF"                  /* ............ */
};


data 'mitq' (0) {
	$"0000 12A0"									  /* default 3-bit res queue size */
	$"0000 2200"									  /* default 4-bit res queue size */
	$"0000 3C00"                 					  /* default 5-bit res queue size */
};

