/*	--------------------------------------------------------------------------------------

	Copyright  1990-1991, Apple Computer, Inc, All Rights Reserved.
	
	File:		BaseIncludes.h
		
	Author:		John Farmer
	
	Contains:	Include statements for header files common to the majority of project files.
				Other common header files should be added to this file as needed.
	
	Revisions: (most recent first):
	
		ID		Date		Description
		
		<1>		11/29/90	John Farmer - Create file and it's original contents.
														
	-----------------------------------------------------------------------------------  */


#ifndef			__BaseIncludes__
#define			__BaseIncludes__


// Includes


	#include	"Types.h"
	#include	"BaseTypes.h"
	#include	"BaseConstants.h"
	#include	"Formatting.h"
	#include	"ResourceTypes.h"
	#include	"CompileFlags.h"
	
	
#endif			__BaseIncludes__
